import { computed as m, ref as h, watch as lt, onMounted as at, onBeforeUnmount as ot, openBlock as o, createElementBlock as r, normalizeClass as Ve, normalizeStyle as D, unref as n, createBlock as j, createCommentVNode as c, createSlots as st, withCtx as _, renderSlot as M, normalizeProps as Q, guardReactiveProps as Z, createVNode as pe, createElementVNode as d, Fragment as N, renderList as X, toDisplayString as C, createTextVNode as ut, nextTick as rt } from "vue";
import { u as it, c as nt, t as vt, a as yt, p as q, o as ct, e as fe, b as dt, g as Ee, T as ht, R as pt, Y as ft, X as gt, U as xt, s as ge, i as V, v as z, f as P, x as mt, y as bt, q as kt, r as wt } from "./index-BU-qdyPq.js";
import { t as _t, u as Mt } from "./useResponsive-CoxXLe23.js";
import { _ as $t } from "./Title-BxMjvERL.js";
import { u as Ct, U as zt } from "./usePrinter-CIccmyRB.js";
import { _ as At } from "./Tooltip-VA-KbJNH.js";
import { L as St } from "./Legend-DGRS4QbF.js";
import { _ as Ue } from "./Shape-BL37b4be.js";
import { D as Lt } from "./DataTable-DLDlPv_3.js";
import Tt from "./vue-ui-skeleton-CpFbwUa0.js";
import Bt from "./vue-ui-accordion-CrpdF6x_.js";
import { u as Ge } from "./useNestedProp-CWSJ5eBm.js";
import { _ as Ot } from "./PackageVersion-BN4d5Mju.js";
import { P as Nt } from "./PenAndPaper-CXPVm0x2.js";
import { u as Pt } from "./useUserOptionState-BIvW1Kz7.js";
import { _ as Wt } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const Ft = ["id"], Xt = ["xmlns", "viewBox"], It = ["width", "height"], Yt = { key: 1 }, Dt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], jt = ["x1", "x2", "y1", "y2", "stroke", "stroke-width"], Vt = { key: 2 }, Et = ["points", "fill", "stroke-width", "stroke-dasharray", "stroke"], Ut = { key: 0 }, Gt = ["cx", "cy", "r", "fill", "stroke", "stroke-width", "onMouseover"], Rt = { key: 1 }, qt = { key: 3 }, Ht = ["id"], Jt = ["stop-color"], Kt = ["stop-color"], Qt = ["id"], Zt = ["stop-color"], el = ["stop-color"], tl = ["x", "y", "width", "height", "fill", "stroke", "stroke-width", "rx"], ll = ["x", "y", "height", "width", "fill", "stroke", "stroke-width", "rx"], al = { key: 0 }, ol = ["d", "stroke", "stroke-width"], sl = ["d", "stroke", "stroke-width"], ul = ["d", "stroke", "stroke-width"], rl = ["d", "stroke", "stroke-width"], il = {
  key: 4,
  style: { "pointer-events": "none !important" }
}, nl = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], vl = ["x1", "x2", "y1", "y2", "stroke", "stroke-width", "stroke-dasharray"], yl = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], cl = ["x", "y", "font-size", "fill", "font-weight"], dl = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], hl = ["cx", "cy", "r", "fill", "stroke", "stroke-width"], pl = ["x", "y", "font-size", "fill", "font-weight", "text-anchor"], fl = { key: 5 }, gl = ["x", "y", "font-size", "fill"], xl = ["x", "y", "font-size", "fill"], ml = ["id", "transform", "font-size", "font-weight", "fill"], bl = { key: 6 }, kl = ["x", "y", "font-size", "fill"], wl = ["x", "y", "font-size", "fill"], _l = ["font-size", "font-weight", "fill", "x", "y"], Ml = ["id"], $l = ["x", "y", "width", "height"], Cl = { key: 7 }, zl = ["x1", "x2", "y1", "y2", "stroke-dasharray", "stroke", "stroke-width", "clip-path"], Al = ["x", "y", "fill", "font-size", "font-weight"], Sl = {
  key: 5,
  class: "vue-data-ui-watermark"
}, Ll = ["onClick"], Tl = {
  key: 0,
  style: { width: "100%", display: "flex", "align-items": "center", "justify-content": "center" }
}, Bl = {
  viewBox: "0 0 20 20",
  height: "20",
  width: "20",
  style: { overflow: "hidden", background: "transparent" }
}, Ol = { key: 0 }, Nl = ["innerHTML"], Pl = {
  __name: "vue-ui-scatter",
  props: {
    config: {
      type: Object,
      default() {
        return {};
      }
    },
    dataset: {
      type: Array,
      default() {
        return [];
      }
    }
  },
  setup(Re, { expose: qe }) {
    const W = Re, { vue_ui_scatter: He } = it(), ee = m(() => !!W.dataset && W.dataset.length), A = h(nt()), Je = h(null), ue = h(!1), re = h(""), xe = h(0), H = h(null), me = h(null), be = h(null), ke = h(null), we = h(null), _e = h(0), Me = h(0), $e = h(0), e = m({
      get: () => Ae(),
      set: (t) => t
    }), { userOptionsVisible: ie, setUserOptionsVisibility: Ce, keepUserOptionState: ze } = Pt({ config: e.value });
    function Ae() {
      const t = Ge({
        userConfig: W.config,
        defaultConfig: He
      });
      return t.theme ? {
        ...Ge({
          userConfig: vt.vue_ui_scatter[t.theme] || W.config,
          defaultConfig: t
        }),
        customPalette: yt[t.theme] || q
      } : t;
    }
    lt(() => W.config, (t) => {
      e.value = Ae(), ie.value = !e.value.showOnChartHover, Se(), _e.value += 1, Me.value += 1, $e.value += 1;
    }, { deep: !0 });
    const te = h(null);
    at(() => {
      Se();
    });
    function Se() {
      if (ct(W.dataset) && fe({
        componentName: "VueUiScatter",
        type: "dataset"
      }), e.value.responsive) {
        const t = _t(() => {
          const { width: u, height: l } = Mt({
            chart: H.value,
            title: e.value.style.title.text ? me.value : null,
            legend: e.value.style.legend.show ? be.value : null,
            source: ke.value,
            noTitle: we.value
          });
          b.value.width = u, b.value.height = l;
        });
        te.value = new ResizeObserver(t), te.value.observe(H.value.parentNode);
      }
    }
    ot(() => {
      te.value && te.value.disconnect();
    });
    const { isPrinting: Le, isImaging: Te, generatePdf: Be, generateImage: Oe } = Ct({
      elementId: `vue-ui-scatter_${A.value}`,
      fileName: e.value.style.title.text || "vue-ui-scatter"
    }), Ke = m(() => e.value.userOptions.show && !e.value.style.title.text), Ne = m(() => dt(e.value.customPalette)), I = h({
      showTable: e.value.table.show,
      showTooltip: e.value.style.tooltip.show
    }), b = h({
      height: e.value.style.layout.height,
      width: e.value.style.layout.width
    }), le = m(() => e.value.style.layout.marginalBars.show ? e.value.style.layout.marginalBars.size + e.value.style.layout.marginalBars.offset : 0), i = m(() => ({
      top: e.value.style.layout.padding.top + le.value,
      right: b.value.width - e.value.style.layout.padding.right - le.value,
      bottom: b.value.height - e.value.style.layout.padding.bottom,
      left: e.value.style.layout.padding.left,
      height: b.value.height - e.value.style.layout.padding.top - e.value.style.layout.padding.bottom - le.value,
      width: b.value.width - e.value.style.layout.padding.left - e.value.style.layout.padding.right - le.value
    })), p = m(() => {
      W.dataset.forEach((a, v) => {
        Ee({
          datasetObject: a,
          requiredAttributes: ["values"]
        }).forEach((k) => {
          fe({
            componentName: "VueUiScatter",
            type: "datasetSerieAttribute",
            property: k,
            index: v
          });
        }), a.values && a.values.forEach((k, U) => {
          Ee({
            datasetObject: k,
            requiredAttributes: ["x", "y"]
          }).forEach((K) => {
            fe({
              componentName: "VueUiScatter",
              type: "datasetSerieAttribute",
              property: `values.${K}`,
              index: `${v} - ${U}`
            });
          });
        });
      });
      const t = Math.min(...E.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((v) => v.x))), u = Math.max(...E.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((v) => v.x))), l = Math.min(...E.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((v) => v.y))), s = Math.max(...E.value.filter((a) => !x.value.includes(a.id)).flatMap((a) => a.values.map((v) => v.y)));
      return { xMin: t >= 0 ? 0 : t, xMax: u, yMin: l >= 0 ? 0 : l, yMax: s };
    }), f = m(() => ({
      x: i.value.left + Math.abs(p.value.xMin) / (p.value.xMax + Math.abs(p.value.xMin)) * i.value.width,
      y: i.value.bottom - Math.abs(p.value.yMin) / (p.value.yMax + Math.abs(p.value.yMin)) * i.value.height
    })), E = m(() => W.dataset.map((t, u) => {
      const l = `cluster_${A.value}_${u}`;
      return {
        ...t,
        values: ht({
          data: t.values,
          threshold: e.value.downsample.threshold
        }),
        id: l,
        color: t.color ? t.color : Ne.value[u] || q[u] || q[u % q.length],
        opacity: x.value.includes(l) ? 0.5 : 1,
        shape: t.shape ?? "circle",
        segregate: () => Ie(l),
        isSegregated: x.value.includes(l)
      };
    })), Qe = m(() => ({
      cy: "scatter-div-legend",
      backgroundColor: e.value.style.legend.backgroundColor,
      color: e.value.style.legend.color,
      fontSize: e.value.style.legend.fontSize,
      paddingBottom: 12,
      fontWeight: e.value.style.legend.bold ? "bold" : ""
    })), ne = m(() => E.value.map((t, u) => ({
      ...t,
      plots: t.values.map((l) => ({
        x: i.value.left + (l.x + Math.abs(p.value.xMin)) / (p.value.xMax + Math.abs(p.value.xMin)) * i.value.width,
        y: i.value.bottom - (l.y + Math.abs(p.value.yMin)) / (p.value.yMax + Math.abs(p.value.yMin)) * i.value.height,
        v: {
          ...l,
          name: l.name || ""
        },
        clusterName: t.name,
        color: t.color ? t.color : Ne.value[u] || q[u] || q[u % q.length],
        id: `plot_${A.value}_${Math.random()}`,
        weight: l.weight ?? e.value.style.layout.plots.radius
      }))
    })).filter((t) => !x.value.includes(t.id))), S = m(() => ne.value.map((t) => {
      const u = t.plots.reduce((g, G) => g + G.x, 0) / t.plots.length, l = t.plots.reduce((g, G) => g + G.y, 0) / t.plots.length;
      let s = 0, a = 0, v = 0;
      for (const g of t.plots)
        s += (g.x - u) * (g.y - l), a += (g.x - u) ** 2, v += (g.y - l) ** 2;
      const k = s / Math.sqrt(a * v), U = k * (Math.sqrt(v) / Math.sqrt(a)), K = l - U * u, O = {
        x1: i.value.left,
        x2: i.value.right,
        y1: U * i.value.left + K,
        y2: U * i.value.right + K,
        coefficient: k
      }, $ = (O.y2 - O.y1) / (O.x2 - O.x1), T = O.y1 - $ * O.x1, F = Math.min(b.value.width - e.value.style.layout.padding.right, Math.max(e.value.style.layout.padding.left, (i.value.top - T) / $)), se = {
        x: F,
        y: $ * F + T <= e.value.style.layout.padding.top ? i.value.top : $ * F + T
      };
      return {
        ...t,
        correlation: O,
        label: se,
        plots: t.plots.map((g) => {
          const G = (g.x + $ * g.y - $ * T) / (1 + Math.pow($, 2)), ce = ($ * g.x + Math.pow($, 2) * g.y + T) / (1 + Math.pow($, 2)), w = Math.sqrt(Math.pow(g.x - G, 2) + Math.pow(g.y - ce, 2));
          return {
            ...g,
            deviation: w,
            shape: t.shape,
            color: t.color
          };
        })
      };
    })), Pe = m(() => Math.max(...S.value.flatMap((t) => t.plots.map((u) => Math.abs(u.deviation)))));
    function Ze() {
      return S.value;
    }
    function We(t, u) {
      const l = Array.isArray(t) ? t.flatMap((w) => w.plots.map((R) => ({
        x: R.x,
        y: R.y
      }))) : t.plots.map((w) => ({
        x: w.x,
        y: w.y
      }));
      let s = 1 / 0, a = -1 / 0, v = 1 / 0, k = -1 / 0;
      l.forEach(({ x: w, y: R }) => {
        s = Math.min(s, w), a = Math.max(a, w), v = Math.min(v, R), k = Math.max(k, R);
      });
      const U = a - s, K = k - v, O = U / u, $ = K / u, T = Array(u).fill(0), F = Array(u).fill(0);
      l.forEach(({ x: w, y: R }) => {
        const de = Math.floor((w - s) / O), he = Math.floor((R - v) / $);
        T[de] || (T[de] = 0), F[he] || (F[he] = 0), T[de] += 1, F[he] += 1;
      });
      const se = [], g = [];
      for (let w = 0; w < u; w += 1)
        se.push(s + (w + 0.5) * O), g.push(v + (w + 0.5) * $);
      const G = Math.max(...T), ce = Math.max(...F);
      return { x: T, y: F, avgX: se, avgY: g, maxX: G, maxY: ce };
    }
    const Y = m(() => e.value.style.layout.marginalBars.tranches), L = m(() => We(ne.value, Y.value)), et = m(() => {
      const t = i.value.top - e.value.style.layout.marginalBars.offset, u = i.value.right + e.value.style.layout.marginalBars.offset;
      return ne.value.map((l) => {
        const s = We(l, Y.value);
        return {
          coords: s,
          dX: pt(s.avgX.map((a, v) => ({
            x: a,
            y: t - s.x[v] / s.maxX * e.value.style.layout.marginalBars.size
          }))),
          dY: ft(s.avgY.map((a, v) => ({
            y: a,
            x: u + e.value.style.layout.marginalBars.size * s.y[v] / s.maxY
          }))),
          color: l.color,
          id: l.id
        };
      });
    }), B = h(void 0), y = h(null), ve = h(null);
    function Fe(t, u) {
      B.value = t.id, y.value = t;
      let l = "";
      ve.value = {
        datapoint: t,
        seriesIndex: u,
        series: S.value,
        config: e.value
      };
      const s = e.value.style.tooltip.customFormat;
      mt(s) && bt(() => s({
        datapoint: t,
        seriesIndex: u,
        series: S.value,
        config: e.value
      })) ? re.value = s({
        datapoint: t,
        seriesIndex: u,
        series: S.value,
        config: e.value
      }) : (t.clusterName && (l += `<div style="display:flex;gap:3px;align-items:center">${t.clusterName}</div>`), t.v.name && (l += `<div>${t.v.name}</div>`), l += `<div style="text-align:left;margin-top:6px;padding-top:6px;border-top:1px solid ${e.value.style.tooltip.borderColor}">`, l += `<div>${e.value.style.layout.dataLabels.xAxis.name}: <b>${isNaN(t.v.x) ? "-" : V(
        e.value.style.layout.plots.selectors.labels.x.formatter,
        t.v.x,
        P({
          p: e.value.style.tooltip.prefix,
          v: t.v.x,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: t, seriesIndex: u }
      )}</b></div>`, l += `<div>${e.value.style.layout.dataLabels.yAxis.name}: <b>${isNaN(t.v.y) ? "-" : V(
        e.value.style.layout.plots.selectors.labels.y.formatter,
        t.v.y,
        P({
          p: e.value.style.tooltip.prefix,
          v: t.v.y,
          s: e.value.style.tooltip.suffix,
          r: e.value.style.tooltip.roundingValue
        }),
        { datapoint: t, seriesIndex: u }
      )}</b></div>`, l += `${e.value.style.layout.plots.deviation.translation}: <b>${P({
        v: t.deviation,
        r: e.value.style.layout.plots.deviation.roundingValue
      })}</b>`, l += "</div>", re.value = `<div>${l}</div>`), ue.value = !0;
    }
    function Xe() {
      ue.value = !1, B.value = void 0, y.value = null;
    }
    const x = h([]);
    function Ie(t) {
      x.value.includes(t) ? x.value = x.value.filter((u) => u !== t) : x.value.length < W.dataset.length - 1 && x.value.push(t);
    }
    function Ye() {
      rt(() => {
        const t = ["", e.value.table.translations.correlationCoefficient, e.value.table.translations.nbrPlots, `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`, `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`], u = S.value.map((a) => [
          a.name,
          a.correlation.coefficient,
          a.plots.length,
          a.plots.map((v) => v.v.x).reduce((v, k) => v + k, 0) / a.plots.length,
          a.plots.map((v) => v.v.y).reduce((v, k) => v + k, 0) / a.plots.length
        ]), l = [[e.value.style.title.text], [e.value.style.title.subtitle.text], [[""], [""], [""]]].concat([t]).concat(u), s = kt(l);
        wt({ csvContent: s, title: e.value.style.title.text || "vue-ui-heatmap" });
      });
    }
    const ae = m(() => {
      const t = [
        e.value.table.translations.series,
        e.value.table.translations.correlationCoefficient,
        e.value.table.translations.nbrPlots,
        `${e.value.style.layout.dataLabels.xAxis.name} ${e.value.table.translations.average}`,
        `${e.value.style.layout.dataLabels.yAxis.name} ${e.value.table.translations.average}`
      ], u = S.value.map((s) => [
        {
          shape: s.shape,
          content: s.name,
          color: s.color
        },
        Number((s.correlation.coefficient ?? 0).toFixed(e.value.table.td.roundingValue)).toLocaleString(),
        s.plots.length.toLocaleString(),
        Number((s.plots.map((a) => a.v.x ?? 0).reduce((a, v) => a + v, 0) / s.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString(),
        Number((s.plots.map((a) => a.v.y ?? 0).reduce((a, v) => a + v, 0) / s.plots.length).toFixed(e.value.table.td.roundingAverage)).toLocaleString()
      ]), l = {
        th: {
          backgroundColor: e.value.table.th.backgroundColor,
          color: e.value.table.th.color,
          outline: e.value.table.th.outline
        },
        td: {
          backgroundColor: e.value.table.td.backgroundColor,
          color: e.value.table.td.color,
          outline: e.value.table.td.outline
        },
        breakpoint: e.value.table.responsiveBreakpoint
      };
      return { head: t, body: u, config: l, colNames: t };
    }), J = h(!1);
    function tt(t) {
      J.value = t, xe.value += 1;
    }
    function De() {
      I.value.showTable = !I.value.showTable;
    }
    function je() {
      I.value.showTooltip = !I.value.showTooltip;
    }
    const oe = h(!1);
    function ye() {
      oe.value = !oe.value;
    }
    return qe({
      getData: Ze,
      generatePdf: Be,
      generateCsv: Ye,
      generateImage: Oe,
      toggleTable: De,
      toggleTooltip: je,
      toggleAnnotator: ye
    }), (t, u) => (o(), r("div", {
      class: Ve(`vue-ui-scatter ${J.value ? "vue-data-ui-wrapper-fullscreen" : ""} ${e.value.useCssAnimation ? "" : "vue-ui-dna"}`),
      ref_key: "scatterChart",
      ref: H,
      id: `vue-ui-scatter_${A.value}`,
      style: D(`font-family:${e.value.style.fontFamily};width:100%; text-align:center;background:${e.value.style.backgroundColor};${e.value.responsive ? "height: 100%" : ""}`),
      onMouseenter: u[2] || (u[2] = () => n(Ce)(!0)),
      onMouseleave: u[3] || (u[3] = () => n(Ce)(!1))
    }, [
      e.value.userOptions.buttons.annotator ? (o(), j(Nt, {
        key: 0,
        parent: H.value,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        active: oe.value,
        onClose: ye
      }, null, 8, ["parent", "backgroundColor", "color", "active"])) : c("", !0),
      Ke.value ? (o(), r("div", {
        key: 1,
        ref_key: "noTitle",
        ref: we,
        class: "vue-data-ui-no-title-space",
        style: "height:36px; width: 100%;background:transparent"
      }, null, 512)) : c("", !0),
      e.value.style.title.text ? (o(), r("div", {
        key: 2,
        ref_key: "chartTitle",
        ref: me,
        style: "width:100%;background:transparent"
      }, [
        (o(), j($t, {
          key: `title_${_e.value}`,
          config: {
            title: {
              cy: "scatter-div-title",
              ...e.value.style.title
            },
            subtitle: {
              cy: "scatter-div-subtitle",
              ...e.value.style.title.subtitle
            }
          }
        }, null, 8, ["config"]))
      ], 512)) : c("", !0),
      e.value.userOptions.show && ee.value && (n(ze) || n(ie)) ? (o(), j(zt, {
        ref_key: "details",
        ref: Je,
        key: `user_options_${xe.value}`,
        backgroundColor: e.value.style.backgroundColor,
        color: e.value.style.color,
        isImaging: n(Te),
        isPrinting: n(Le),
        uid: A.value,
        hasTooltip: e.value.userOptions.buttons.tooltip && e.value.style.tooltip.show,
        hasPdf: e.value.userOptions.buttons.pdf,
        hasImg: e.value.userOptions.buttons.img,
        hasXls: e.value.userOptions.buttons.csv,
        hasTable: e.value.userOptions.buttons.table,
        hasFullscreen: e.value.userOptions.buttons.fullscreen,
        isTooltip: I.value.showTooltip,
        isFullscreen: J.value,
        titles: { ...e.value.userOptions.buttonTitles },
        chartElement: H.value,
        position: e.value.userOptions.position,
        hasAnnotator: e.value.userOptions.buttons.annotator,
        isAnnotation: oe.value,
        onToggleFullscreen: tt,
        onGeneratePdf: n(Be),
        onGenerateCsv: Ye,
        onGenerateImage: n(Oe),
        onToggleTable: De,
        onToggleTooltip: je,
        onToggleAnnotator: ye,
        style: D({
          visibility: n(ze) ? n(ie) ? "visible" : "hidden" : "visible"
        })
      }, st({ _: 2 }, [
        t.$slots.optionTooltip ? {
          name: "optionTooltip",
          fn: _(() => [
            M(t.$slots, "optionTooltip", {}, void 0, !0)
          ]),
          key: "0"
        } : void 0,
        t.$slots.optionPdf ? {
          name: "optionPdf",
          fn: _(() => [
            M(t.$slots, "optionPdf", {}, void 0, !0)
          ]),
          key: "1"
        } : void 0,
        t.$slots.optionCsv ? {
          name: "optionCsv",
          fn: _(() => [
            M(t.$slots, "optionCsv", {}, void 0, !0)
          ]),
          key: "2"
        } : void 0,
        t.$slots.optionImg ? {
          name: "optionImg",
          fn: _(() => [
            M(t.$slots, "optionImg", {}, void 0, !0)
          ]),
          key: "3"
        } : void 0,
        t.$slots.optionTable ? {
          name: "optionTable",
          fn: _(() => [
            M(t.$slots, "optionTable", {}, void 0, !0)
          ]),
          key: "4"
        } : void 0,
        t.$slots.optionFullscreen ? {
          name: "optionFullscreen",
          fn: _(({ toggleFullscreen: l, isFullscreen: s }) => [
            M(t.$slots, "optionFullscreen", Q(Z({ toggleFullscreen: l, isFullscreen: s })), void 0, !0)
          ]),
          key: "5"
        } : void 0,
        t.$slots.optionAnnotator ? {
          name: "optionAnnotator",
          fn: _(({ toggleAnnotator: l, isAnnotator: s }) => [
            M(t.$slots, "optionAnnotator", Q(Z({ toggleAnnotator: l, isAnnotator: s })), void 0, !0)
          ]),
          key: "6"
        } : void 0
      ]), 1032, ["backgroundColor", "color", "isImaging", "isPrinting", "uid", "hasTooltip", "hasPdf", "hasImg", "hasXls", "hasTable", "hasFullscreen", "isTooltip", "isFullscreen", "titles", "chartElement", "position", "hasAnnotator", "isAnnotation", "onGeneratePdf", "onGenerateImage", "style"])) : c("", !0),
      ee.value ? (o(), r("svg", {
        key: 4,
        xmlns: n(gt),
        class: Ve({ "vue-data-ui-fullscreen--on": J.value, "vue-data-ui-fulscreen--off": !J.value }),
        viewBox: `0 0 ${b.value.width <= 0 ? 10 : b.value.width} ${b.value.height <= 0 ? 10 : b.value.height}`,
        style: D(`max-width:100%;overflow:visible;background:transparent;color:${e.value.style.color}`)
      }, [
        pe(Ot),
        t.$slots["chart-background"] ? (o(), r("foreignObject", {
          key: 0,
          x: 0,
          y: 0,
          width: b.value.width <= 0 ? 10 : b.value.width,
          height: b.value.height <= 0 ? 10 : b.value.height,
          style: {
            pointerEvents: "none"
          }
        }, [
          M(t.$slots, "chart-background", {}, void 0, !0)
        ], 8, It)) : c("", !0),
        e.value.style.layout.axis.show ? (o(), r("g", Yt, [
          d("line", {
            x1: f.value.x,
            x2: f.value.x,
            y1: i.value.top,
            y2: i.value.bottom,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, Dt),
          d("line", {
            x1: i.value.left,
            x2: i.value.right,
            y1: f.value.y,
            y2: f.value.y,
            stroke: e.value.style.layout.axis.stroke,
            "stroke-width": e.value.style.layout.axis.strokeWidth,
            "stroke-linecap": "round"
          }, null, 8, jt)
        ])) : c("", !0),
        e.value.style.layout.plots.giftWrap.show ? (o(), r("g", Vt, [
          (o(!0), r(N, null, X(S.value, (l, s) => (o(), r("g", null, [
            l.plots.length > 2 ? (o(), r("polygon", {
              key: 0,
              points: n(xt)({ series: l.plots }),
              fill: n(ge)(l.color, e.value.style.layout.plots.giftWrap.fillOpacity * 100),
              "stroke-width": e.value.style.layout.plots.giftWrap.strokeWidth,
              "stroke-dasharray": e.value.style.layout.plots.giftWrap.strokeDasharray,
              stroke: l.color,
              "stroke-linejoin": "round",
              "stroke-linecap": "round"
            }, null, 8, Et)) : c("", !0)
          ]))), 256))
        ])) : c("", !0),
        (o(!0), r(N, null, X(S.value, (l, s) => (o(), r("g", null, [
          !l.shape || l.shape === "circle" ? (o(), r("g", Ut, [
            (o(!0), r(N, null, X(l.plots, (a, v) => (o(), r("circle", {
              cx: a.x,
              cy: a.y,
              r: B.value && B.value === a.id ? a.weight * 2 : a.weight,
              fill: n(ge)(l.color, e.value.style.layout.plots.opacity * 100),
              stroke: e.value.style.layout.plots.stroke,
              "stroke-width": e.value.style.layout.plots.strokeWidth,
              onMouseover: (k) => Fe(a, s),
              onMouseleave: Xe,
              style: D(`opacity:${B.value && B.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / Pe.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 44, Gt))), 256))
          ])) : (o(), r("g", Rt, [
            (o(!0), r(N, null, X(l.plots, (a, v) => (o(), j(Ue, {
              plot: { x: a.x, y: a.y },
              radius: B.value && B.value === a.id ? a.weight * 2 : a.weight,
              shape: l.shape,
              color: n(ge)(l.color, e.value.style.layout.plots.opacity * 100),
              stroke: e.value.style.layout.plots.stroke,
              strokeWidth: e.value.style.layout.plots.strokeWidth,
              onMouseover: (k) => Fe(a, s),
              onMouseleave: Xe,
              style: D(`opacity:${B.value && B.value === a.id ? 1 : e.value.style.layout.plots.significance.useDistanceOpacity ? 1 - Math.abs(a.deviation) / Pe.value : e.value.style.layout.plots.significance.show && Math.abs(a.deviation) > e.value.style.layout.plots.significance.deviationThreshold ? e.value.style.layout.plots.significance.opacity : 1}`)
            }, null, 8, ["plot", "radius", "shape", "color", "stroke", "strokeWidth", "onMouseover", "style"]))), 256))
          ]))
        ]))), 256)),
        e.value.style.layout.marginalBars.show ? (o(), r("g", qt, [
          d("defs", null, [
            d("linearGradient", {
              id: `marginal_x_${A.value}`,
              x1: "0%",
              y1: "0%",
              x2: "0%",
              y2: "100%"
            }, [
              d("stop", {
                offset: "0%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, Jt),
              d("stop", {
                offset: "100%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, Kt)
            ], 8, Ht),
            d("linearGradient", {
              id: `marginal_y_${A.value}`,
              x1: "0%",
              x2: "100%",
              y1: "0%",
              y2: "0%"
            }, [
              d("stop", {
                offset: "0%",
                "stop-color": e.value.style.backgroundColor
              }, null, 8, Zt),
              d("stop", {
                offset: "100%",
                "stop-color": e.value.style.layout.marginalBars.fill
              }, null, 8, el)
            ], 8, Qt)
          ]),
          (o(!0), r(N, null, X(L.value.x, (l, s) => (o(), r("g", null, [
            l && L.value.avgX[s] ? (o(), r("rect", {
              key: 0,
              x: L.value.avgX[s] - i.value.width / Y.value / 2,
              y: i.value.top - e.value.style.layout.marginalBars.offset - l / L.value.maxX * e.value.style.layout.marginalBars.size,
              width: i.value.width / Y.value <= 0 ? 1e-4 : i.value.width / Y.value,
              height: l / L.value.maxX * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : l / L.value.maxX * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_x_${A.value})` : e.value.style.layout.marginalBars.fill,
              style: D(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, tl)) : c("", !0)
          ]))), 256)),
          (o(!0), r(N, null, X(L.value.y, (l, s) => (o(), r("g", null, [
            l && L.value.avgY[s] ? (o(), r("rect", {
              key: 0,
              x: i.value.right + e.value.style.layout.marginalBars.offset,
              y: L.value.avgY[s] - i.value.height / Y.value / 2,
              height: i.value.height / Y.value <= 0 ? 1e-4 : i.value.height / Y.value,
              width: l / L.value.maxY * e.value.style.layout.marginalBars.size <= 0 ? 1e-4 : l / L.value.maxY * e.value.style.layout.marginalBars.size,
              fill: e.value.style.layout.marginalBars.useGradient ? `url(#marginal_y_${A.value})` : e.value.style.layout.marginalBars.fill,
              style: D(`opacity:${e.value.style.layout.marginalBars.opacity}`),
              stroke: e.value.style.backgroundColor,
              "stroke-width": e.value.style.layout.marginalBars.strokeWidth,
              rx: e.value.style.layout.marginalBars.borderRadius
            }, null, 12, ll)) : c("", !0)
          ]))), 256)),
          e.value.style.layout.marginalBars.showLines ? (o(), r("g", al, [
            (o(!0), r(N, null, X(et.value, (l) => (o(), r(N, null, [
              x.value.includes(l.id) ? c("", !0) : (o(), r("path", {
                key: 0,
                d: `M ${l.dX}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, ol)),
              x.value.includes(l.id) ? c("", !0) : (o(), r("path", {
                key: 1,
                d: `M ${l.dX}`,
                stroke: l.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, sl)),
              x.value.includes(l.id) ? c("", !0) : (o(), r("path", {
                key: 2,
                d: `M ${l.dY}`,
                stroke: e.value.style.backgroundColor,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth + 1,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, ul)),
              x.value.includes(l.id) ? c("", !0) : (o(), r("path", {
                key: 3,
                d: `M ${l.dY}`,
                stroke: l.color,
                "stroke-width": e.value.style.layout.marginalBars.linesStrokeWidth,
                "stroke-linecap": "round",
                "stroke-linejoin": "round",
                fill: "none"
              }, null, 8, rl))
            ], 64))), 256))
          ])) : c("", !0)
        ])) : c("", !0),
        y.value && e.value.style.layout.plots.selectors.show ? (o(), r("g", il, [
          d("line", {
            x1: f.value.x,
            x2: y.value.x,
            y1: y.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, nl),
          d("line", {
            x1: y.value.x,
            x2: y.value.x,
            y1: f.value.y,
            y2: y.value.y,
            stroke: e.value.style.layout.plots.selectors.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.strokeWidth,
            "stroke-dasharray": e.value.style.layout.plots.selectors.strokeDasharray,
            "stroke-linecap": "round",
            class: "line-pointer"
          }, null, 8, vl),
          d("text", {
            x: f.value.x + (y.value.x > f.value.x ? -6 : 6),
            y: y.value.y + e.value.style.layout.plots.selectors.labels.fontSize / 3,
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x > f.value.x ? "end" : "start"
          }, C(n(V)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            n(z)(y.value.v.y),
            n(P)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: n(z)(y.value.v.y),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, yl),
          d("text", {
            x: y.value.x,
            y: f.value.y + (y.value.y > f.value.y ? -6 : e.value.style.layout.plots.selectors.labels.fontSize + 6),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": "middle"
          }, C(n(V)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            n(z)(y.value.v.x),
            n(P)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: n(z)(y.value.v.x),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.plots.selectors.labels.rounding
            }),
            { datapoint: y.value }
          )), 9, cl),
          d("circle", {
            cx: f.value.x,
            cy: y.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, dl),
          d("circle", {
            cx: y.value.x,
            cy: f.value.y,
            r: e.value.style.layout.plots.selectors.markers.radius,
            fill: e.value.style.layout.plots.selectors.markers.fill,
            stroke: e.value.style.layout.plots.selectors.markers.stroke,
            "stroke-width": e.value.style.layout.plots.selectors.markers.strokeWidth,
            class: "line-pointer"
          }, null, 8, hl),
          e.value.style.layout.plots.selectors.labels.showName ? (o(), r("text", {
            key: 0,
            x: y.value.x,
            y: y.value.y + (y.value.y < f.value.y ? -e.value.style.layout.plots.selectors.labels.fontSize / 2 : e.value.style.layout.plots.selectors.labels.fontSize),
            "font-size": e.value.style.layout.plots.selectors.labels.fontSize,
            fill: e.value.style.layout.plots.selectors.labels.color,
            "font-weight": e.value.style.layout.plots.selectors.labels.bold ? "bold" : "normal",
            "text-anchor": y.value.x < i.value.left + 100 ? "start" : y.value.x > i.value.right - 100 ? "end" : y.value.x > f.value.x ? "start" : "end"
          }, C(y.value.v.name), 9, pl)) : c("", !0)
        ])) : c("", !0),
        e.value.style.layout.dataLabels.xAxis.show ? (o(), r("g", fl, [
          d("text", {
            x: i.value.left - 5,
            y: f.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "end",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, C(n(V)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            n(z)(p.value.xMin),
            n(P)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: n(z)(p.value.xMin),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, gl),
          d("text", {
            x: i.value.right + 3,
            y: f.value.y + e.value.style.layout.dataLabels.xAxis.fontSize / 3,
            "text-anchor": "start",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, C(n(V)(
            e.value.style.layout.plots.selectors.labels.x.formatter,
            n(z)(p.value.xMax),
            n(P)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: n(z)(p.value.xMax),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.xAxis.rounding
            })
          )), 9, xl),
          d("text", {
            id: `vue-ui-scatter-xAxis-label-${A.value}`,
            transform: `translate(${e.value.style.layout.dataLabels.xAxis.fontSize * 2}, ${i.value.top + i.value.height / 2}), rotate(-90)`,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.xAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.xAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.xAxis.color
          }, C(e.value.style.layout.dataLabels.xAxis.name), 9, ml)
        ])) : c("", !0),
        e.value.style.layout.dataLabels.yAxis.show ? (o(), r("g", bl, [
          d("text", {
            x: f.value.x,
            y: i.value.bottom + e.value.style.layout.dataLabels.yAxis.fontSize + 3,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, C(n(V)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            n(z)(p.value.yMin),
            n(P)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: n(z)(p.value.yMin),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, kl),
          d("text", {
            x: f.value.x,
            y: i.value.top - e.value.style.layout.dataLabels.yAxis.fontSize / 2,
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            fill: e.value.style.layout.dataLabels.yAxis.color
          }, C(n(V)(
            e.value.style.layout.plots.selectors.labels.y.formatter,
            n(z)(p.value.yMax),
            n(P)({
              p: e.value.style.layout.plots.selectors.labels.prefix,
              v: n(z)(p.value.yMax),
              s: e.value.style.layout.plots.selectors.labels.suffix,
              r: e.value.style.layout.dataLabels.yAxis.rounding
            })
          )), 9, wl),
          d("text", {
            "text-anchor": "middle",
            "font-size": e.value.style.layout.dataLabels.yAxis.fontSize,
            "font-weight": e.value.style.layout.dataLabels.yAxis.bold ? "bold" : "normal",
            fill: e.value.style.layout.dataLabels.yAxis.color,
            x: i.value.left + i.value.width / 2,
            y: i.value.bottom + 8 + e.value.style.layout.dataLabels.yAxis.fontSize * 2
          }, C(e.value.style.layout.dataLabels.yAxis.name), 9, _l)
        ])) : c("", !0),
        d("clipPath", {
          id: `clip_path_${A.value}`
        }, [
          d("rect", {
            x: i.value.left,
            y: i.value.top,
            width: i.value.width <= 0 ? 1e-4 : i.value.width,
            height: i.value.height <= 0 ? 1e-4 : i.value.height
          }, null, 8, $l)
        ], 8, Ml),
        e.value.style.layout.correlation.show ? (o(), r("g", Cl, [
          (o(!0), r(N, null, X(S.value, (l, s) => (o(), r("line", {
            x1: l.correlation.x1,
            x2: l.correlation.x2,
            y1: l.correlation.y1,
            y2: l.correlation.y2,
            "stroke-dasharray": e.value.style.layout.correlation.strokeDasharray,
            stroke: l.color,
            "stroke-width": e.value.style.layout.correlation.strokeWidth,
            "clip-path": `url(#clip_path_${A.value})`
          }, null, 8, zl))), 256)),
          (o(!0), r(N, null, X(S.value, (l, s) => (o(), r("g", null, [
            e.value.style.layout.correlation.label.show ? (o(), r("text", {
              key: 0,
              x: l.label.x,
              y: l.label.y,
              fill: e.value.style.layout.correlation.label.useSerieColor ? l.color : e.value.style.layout.correlation.label.color,
              "font-size": e.value.style.layout.correlation.label.fontSize,
              "font-weight": e.value.style.layout.correlation.label.bold ? "bold" : "normal"
            }, C(n(P)({
              v: n(z)(l.correlation.coefficient),
              r: e.value.style.layout.correlation.label.roundingValue
            })), 9, Al)) : c("", !0)
          ]))), 256))
        ])) : c("", !0),
        M(t.$slots, "svg", { svg: b.value }, void 0, !0)
      ], 14, Xt)) : c("", !0),
      t.$slots.watermark ? (o(), r("div", Sl, [
        M(t.$slots, "watermark", Q(Z({ isPrinting: n(Le) || n(Te) })), void 0, !0)
      ])) : c("", !0),
      ee.value ? c("", !0) : (o(), j(Tt, {
        key: 6,
        config: {
          type: "quadrant",
          style: {
            backgroundColor: e.value.style.backgroundColor,
            quadrant: {
              grid: {
                color: e.value.style.layout.axis.stroke
              },
              plots: {
                color: e.value.style.layout.axis.stroke,
                radius: 1
              }
            }
          }
        }
      }, null, 8, ["config"])),
      d("div", {
        ref_key: "chartLegend",
        ref: be
      }, [
        e.value.style.legend.show ? (o(), j(St, {
          key: `legend_${$e.value}`,
          legendSet: E.value,
          config: Qe.value,
          onClickMarker: u[0] || (u[0] = ({ legend: l }) => Ie(l.id))
        }, {
          item: _(({ legend: l }) => [
            d("div", {
              onClick: (s) => l.segregate(),
              style: D(`opacity:${x.value.includes(l.id) ? 0.5 : 1}`)
            }, C(l.name), 13, Ll)
          ]),
          _: 1
        }, 8, ["legendSet", "config"])) : M(t.$slots, "legend", {
          key: 1,
          legend: E.value
        }, void 0, !0)
      ], 512),
      t.$slots.source ? (o(), r("div", {
        key: 7,
        ref_key: "source",
        ref: ke,
        dir: "auto"
      }, [
        M(t.$slots, "source", {}, void 0, !0)
      ], 512)) : c("", !0),
      pe(At, {
        show: I.value.showTooltip && ue.value,
        backgroundColor: e.value.style.tooltip.backgroundColor,
        color: e.value.style.tooltip.color,
        borderRadius: e.value.style.tooltip.borderRadius,
        borderColor: e.value.style.tooltip.borderColor,
        borderWidth: e.value.style.tooltip.borderWidth,
        fontSize: e.value.style.tooltip.fontSize,
        backgroundOpacity: e.value.style.tooltip.backgroundOpacity,
        position: e.value.style.tooltip.position,
        offsetY: e.value.style.tooltip.offsetY,
        parent: H.value,
        content: re.value,
        isFullscreen: J.value,
        isCustom: e.value.style.tooltip.customFormat && typeof e.value.style.tooltip.customFormat == "function"
      }, {
        "tooltip-before": _(() => [
          M(t.$slots, "tooltip-before", Q(Z({ ...ve.value })), void 0, !0)
        ]),
        "tooltip-after": _(() => [
          M(t.$slots, "tooltip-after", Q(Z({ ...ve.value })), void 0, !0)
        ]),
        default: _(() => [
          e.value.style.tooltip.showShape ? (o(), r("div", Tl, [
            (o(), r("svg", Bl, [
              pe(Ue, {
                shape: y.value.shape,
                color: y.value.color,
                plot: { x: 10, y: 10 },
                radius: 7
              }, null, 8, ["shape", "color"])
            ]))
          ])) : c("", !0)
        ]),
        _: 3
      }, 8, ["show", "backgroundColor", "color", "borderRadius", "borderColor", "borderWidth", "fontSize", "backgroundOpacity", "position", "offsetY", "parent", "content", "isFullscreen", "isCustom"]),
      ee.value ? (o(), j(Bt, {
        key: 8,
        hideDetails: "",
        config: {
          open: I.value.showTable,
          maxHeight: 1e4,
          body: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          },
          head: {
            backgroundColor: e.value.style.backgroundColor,
            color: e.value.style.color
          }
        }
      }, {
        content: _(() => [
          (o(), j(Lt, {
            key: `table_${Me.value}`,
            colNames: ae.value.colNames,
            head: ae.value.head,
            body: ae.value.body,
            config: ae.value.config,
            title: `${e.value.style.title.text}${e.value.style.title.subtitle.text ? ` : ${e.value.style.title.subtitle.text}` : ""}`,
            onClose: u[1] || (u[1] = (l) => I.value.showTable = !1)
          }, {
            th: _(({ th: l }) => [
              ut(C(l), 1)
            ]),
            td: _(({ td: l }) => [
              l.shape ? (o(), r("div", Ol, [
                d("span", null, C(l.content), 1)
              ])) : (o(), r("div", {
                key: 1,
                innerHTML: l
              }, null, 8, Nl))
            ]),
            _: 1
          }, 8, ["colNames", "head", "body", "config", "title"]))
        ]),
        _: 1
      }, 8, ["config"])) : c("", !0)
    ], 46, Ft));
  }
}, Ql = /* @__PURE__ */ Wt(Pl, [["__scopeId", "data-v-19af165c"]]);
export {
  Ql as default
};
